// Generated by CoffeeScript 1.9.0
var app, authentication, checkRooms, config, debug, exec, exportLogs, express, fs, handleproducerrequest, http, httpsOptions, newResonseMethodProducers, producerConnection, requestQueue, timeoutfunction, toggleStandardServer, url, useshttps, _;

config = require('./lib/configLoader');

process.config = config;

_ = require("lodash");

fs = require('fs');

url = require('url');

exec = require("child_process").exec;

producerConnection = require("./lib/producerConnection");

express = require("express.io");

authentication = require('./lib/authentication');

debug = require("debug")("omg-webui_index");

app = express();

useshttps = config.server.https;

if (useshttps) {
  debug("using https");
  httpsOptions = require("./lib/httpsOptions");
  app.https(httpsOptions).io();
} else {
  app.http().io();
  debug("not using https");
}

if (config.server.restartApache) {
  exec("service httpd start");
  delete config.server.restartApache;
  fs.writeFile("/data/config.json", JSON.stringify(config, void 0, 4));
}

app.use(authentication);

app.use(express["static"](__dirname + ("/" + config.server.frontendDir + "/")));

producerConnection.subSocket.on("message", function(data) {
  var msg;
  msg = [];
  Array.prototype.slice.call(arguments).forEach(function(arg) {
    return msg.push(arg.toString());
  });
  data = data.toString();
  return app.io.room(msg[0]).broadcast(msg[0], msg[1]);
});

newResonseMethodProducers = ["numberlist"];

requestQueue = [];

producerConnection.reqSocket.on("message", function(data) {
  var msg, req;
  msg = [];
  Array.prototype.slice.call(arguments).forEach(function(arg) {
    return msg.push(arg.toString());
  });
  req = requestQueue.shift();
  return req.io.emit(msg[0], msg[1]);
});

handleproducerrequest = function(req) {
  var action, producer, rMethod, request, topic;
  request = req.data;
  topic = request.topic;
  producer = request.producer;
  action = request.action;
  rMethod = request.rMethod;
  if (topic === "subscription") {
    if (action === "subscribe") {
      req.io.join(producer);
      producerConnection.pushSocket.send(JSON.stringify(request));
      producerConnection.subSocket.subscribe(producer);
    }
    if (action === "unsubscribe") {
      req.io.leave(producer);
      producerConnection.pushSocket.send(JSON.stringify(request));
      producerConnection.subSocket.subscribe(producer);
    }
  }
  if (topic === "request" || rMethod === "reqrep") {
    if (newResonseMethodProducers.indexOf(producer > -1)) {
      producerConnection.reqSocket.once("message", function(data) {
        var msg;
        msg = [];
        Array.prototype.slice.call(arguments).forEach(function(arg) {
          return msg.push(arg.toString());
        });
        return req.io.respond(msg[1]);
      });
    }
    requestQueue.push(req);
    producerConnection.reqSocket.send(JSON.stringify(request));
  }
  if (topic === "command") {
    return producerConnection.pushSocket.send(JSON.stringify(request));
  }
};

app.io.route("producerAction", handleproducerrequest);

exportLogs = require("./lib/zipLogs");

app.get("/export", exportLogs);

app.get('/ferrariMIB', function(req, res) {
  var file;
  file = '/usr/share/snmp/mibs/FERRARI-ELECTRONIC-MIB.txt';
  return res.download(file);
});

app.get('/licenses.html', function(req, res) {
  return res.sendfile("/oss/licenses.html");
});

toggleStandardServer = require("./lib/toggleServer");

app.io.route("toggleStandardServer", toggleStandardServer);

app.get("/getServerPort", function(req, res) {
  return res.send(JSON.stringify(process.config.server.port));
});

app.get("/createCert", function(req, res) {
  var createCert;
  createCert = require("./lib/createCert.js");
  createCert();
  return res.send(JSON.stringify("done"));
});

app.get("/toggleHttps", function(req, res) {
  config.server.https = !useshttps;
  return fs.writeFile("/data/config.json", JSON.stringify(config, void 0, 4), function() {
    console.log("toggle");
    res.end();
    return exec("service omgWebInterface restart", function(error, stdout, stderr) {
      if (error) {
        console.log(error);
      }
      if (stdout) {
        console.log(stdout);
      }
      if (stderr) {
        return console.log(stderr);
      }
    });
  });
});

if (useshttps) {
  app.listen(443);
  http = require("http");
  http.createServer(function(req, res) {
    var completehost, hostname, newLocation;
    completehost = "http://" + req.headers["host"] + "/" + req.url;
    hostname = url.parse(completehost);
    hostname = hostname.hostname;
    newLocation = "https://" + hostname + req.url;
    console.log(newLocation);
    res.writeHead(301, {
      Location: newLocation
    });
    res.end();
  }).listen(config.server.port);
} else {
  app.listen(config.server.port);
}

timeoutfunction = function() {
  return exec("touch /tmp/*");
};

setTimeout(timeoutfunction, 5000);

checkRooms = function() {
  return _.each(app.io.roomClients, function(rooms) {
    var activeRooms;
    activeRooms = [];
    _.each(rooms, function(active, room) {
      if (active && room) {
        return activeRooms.push(room.slice(1, room.length));
      }
    });
    return _.each(activeRooms, function(room) {
      var resubscription;
      resubscription = {
        producer: room,
        topic: "subscription",
        action: "subscribe"
      };
      return producerConnection.pushSocket.send(JSON.stringify(resubscription));
    });
  });
};

setInterval(checkRooms, 9000);
