// Generated by CoffeeScript 1.9.0
var configJson, configOutOfDate, defaultConfig, fs, _;

fs = require('fs');

_ = require("lodash");

defaultConfig = {
  agg: {
    address: "127.0.0.1",
    subscriberPoolPort: 9008,
    pubSub: 9009,
    reqRep: 9010,
    protocol: "tcp",
    ipcSocketPath: "ipc:///tmp/ipc_sockets/"
  },
  server: {
    port: 8080,
    https: false,
    logLevel: "warn",
    frontendDir: "webApp/bin"
  },
  logger: {
    verbose: false,
    logLevel: "warn",
    logFilePath: false
  },
  environment: "prod",
  sudo: false
};

if (!fs.existsSync("/data/config.json")) {
  console.log("no config file");
  fs.writeFileSync("/data/config.json", JSON.stringify(defaultConfig, void 0, 4));
  console.log("created default config.json");
}

configJson = fs.readFileSync("/data/config.json").toString();

configJson = JSON.parse(configJson);

configOutOfDate = false;

_.each(defaultConfig, function(subConfigObject, configObjectName) {
  var subConfigJson;
  if (!configJson.hasOwnProperty(configObjectName)) {
    console.log("old config: " + configObjectName + " missing");
    configOutOfDate = true;
    configJson[configObjectName] = subConfigObject;
  }
  subConfigJson = configJson[configObjectName];
  if (_.isObject(subConfigObject)) {
    return _.each(subConfigObject, function(value, propName) {
      if (!subConfigJson.hasOwnProperty(propName)) {
        console.log(propName + " old");
        configOutOfDate = true;
        return subConfigJson[propName] = value;
      }
    });
  }
});

if (configOutOfDate) {
  console.log("writing new config...");
  fs.writeFileSync("/data/config.json", JSON.stringify(configJson, void 0, 4));
  console.log("...config updated");
}

if (process.env.DEBUG) {
  if (!process.env.PROD) {
    configJson.server.frontendDir = "webApp/build";
  }
  configJson.server.logLevel = "debug";
  configJson.logger.logLevel = "debug";
}

module.exports = configJson;
