// Generated by CoffeeScript 1.9.0
var EventEmitter, Producer, aggConfig, config, debug, environment, getChanges, host, objectify, pushSocket, zmq, _,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

_ = require("lodash");

zmq = require('zmq');

config = require("/data/config.json");

environment = config.environment;

aggConfig = config.agg;

host = aggConfig.protocol + "://" + aggConfig.address + ":";

EventEmitter = require("events").EventEmitter;

debug = require("debug")("omg-producerClass");

objectify = function(object) {
  var ind, item, newObject, _i, _len;
  if (_.isString(object)) {
    newObject = object;
  } else if (_.isArray(object)) {
    newObject = {};
    for (ind = _i = 0, _len = object.length; _i < _len; ind = ++_i) {
      item = object[ind];
      newObject[ind] = objectify(item);
    }
  } else if (_.isPlainObject(object)) {
    newObject = {};
    for (ind in object) {
      item = object[ind];
      newObject[ind] = objectify(item);
    }
  } else {
    newObject = object;
  }
  return newObject;
};

getChanges = function(prev, now) {
  var changes, nowProp, preProp, prop, subChanges;
  changes = {};
  for (prop in now) {
    if (!prev) {
      return changes = now;
    }
    preProp = prev[prop];
    nowProp = now[prop];
    if (!preProp || (preProp !== nowProp)) {
      if (_.isObject(nowProp)) {
        if (_.isEmpty(nowProp)) {
          changes[prop] = nowProp;
        } else {
          subChanges = getChanges(preProp, nowProp);
          if (subChanges) {
            changes[prop] = subChanges;
          }
        }
      }
      if (_.isString(nowProp)) {
        if (nowProp && !preProp) {
          changes[prop] = nowProp;
        }
        if (preProp !== nowProp) {
          changes[prop] = nowProp;
        }
      }
    }
  }
  if (_.isEmpty(changes)) {
    changes = void 0;
  }
  return changes;
};

pushSocket = zmq.socket("push");

pushSocket.connect("" + host + aggConfig.subscriberPoolPort);

Producer = (function(_super) {
  __extends(Producer, _super);

  function Producer(_at_name, _at_stopIntervalTime) {
    this.name = _at_name;
    this.stopIntervalTime = _at_stopIntervalTime;
    this.getStatus = __bind(this.getStatus, this);
    this.subscribe = __bind(this.subscribe, this);
    this.checkSubscriptionState = __bind(this.checkSubscriptionState, this);
    this.sendError = __bind(this.sendError, this);
    this.sendStatus = __bind(this.sendStatus, this);
    this.sendData = __bind(this.sendData, this);
    this.send = __bind(this.send, this);
    this.unsubscribeFrom = __bind(this.unsubscribeFrom, this);
    this.subscribeTo = __bind(this.subscribeTo, this);
    this.requestData = __bind(this.requestData, this);
    this.replyError = __bind(this.replyError, this);
    this.replyData = __bind(this.replyData, this);

    /*
     There has to be one socket per instance to handle returned messages individually and not block the socket
     */
    this.requestSocket = zmq.socket('req');
    this.requestSocket.connect(host + aggConfig.reqRep);
    this.subSocket = zmq.socket('sub');
    this.subSocket.connect(host + aggConfig.pubSub);
    this.emitter = new EventEmitter();
    this.debug = require("debug")("omg-" + this.name + "_producerClass");
    this.stopInterval = false;
    if (this.stopIntervalTime) {
      this.stopInterval = setInterval(this.checkSubscriptionState, 5000);
    }
    this.subscriptionTime = false;
    this.cache = {};
  }

  Producer.prototype.replyData = function(data, callback) {
    var replyObject;
    replyObject = {
      producer: this.name,
      topic: "data",
      data: data
    };
    replyObject = objectify(replyObject);
    if (!callback) {
      debug("no callback specified");
    }
    return callback(null, replyObject);
  };

  Producer.prototype.replyError = function(err, callback) {
    var replyObject;
    replyObject = {
      producer: this.name,
      topic: "data",
      error: err
    };
    replyObject = objectify(replyObject);
    if (!callback) {
      debug("no callback specified");
    }
    return callback(null, replyObject);
  };

  Producer.prototype.requestData = function(requestObject, callback) {
    var parseZmqMessageAndSend;
    requestObject.topic = "request";
    parseZmqMessageAndSend = function() {
      var data, e, msg;
      msg = [];
      Array.prototype.slice.call(arguments).forEach(function(arg) {
        return msg.push(arg.toString());
      });
      data = msg[1];
      try {
        data = JSON.parse(data);
      } catch (_error) {
        e = _error;
        debug(e);
      }
      return callback(data);
    };
    this.requestSocket.on("message", parseZmqMessageAndSend);
    return this.requestSocket.send(JSON.stringify(requestObject));
  };

  Producer.prototype.subscribeTo = function(producerToSubscribeTo, callback) {
    var parseZmqMessageAndSend, requestObject, unsubscribe;
    requestObject = {
      producer: producerToSubscribeTo,
      topic: "subscription",
      action: "subscribe"
    };
    parseZmqMessageAndSend = function() {
      var data, e, msg;
      msg = [];
      Array.prototype.slice.call(arguments).forEach(function(arg) {
        return msg.push(arg.toString());
      });
      data = msg[1];
      try {
        data = JSON.parse(data);
        data = data.outputMessage;
      } catch (_error) {
        e = _error;
        debug(e);
      }
      return callback(data);
    };
    this.subSocket.on("message", parseZmqMessageAndSend);
    unsubscribe = (function(_this) {
      return function(producer) {
        if (producer === requestObject.producer) {
          _this.subSocket.removeListener("message", parseZmqMessageAndSend);
          return _this.emitter.removeListener("unsubscribe", unsubscribe);
        }
      };
    })(this);
    this.emitter.on("unsubscribe", unsubscribe);
    this.subSocket.subscribe(producerToSubscribeTo);
    return pushSocket.send(JSON.stringify(requestObject));
  };

  Producer.prototype.unsubscribeFrom = function(producerToUnsubscribeFrom) {
    this.subSocket.unsubscribe(producerToUnsubscribeFrom);
    return this.emitter.emit("unsubscribe", producerToUnsubscribeFrom);
  };

  Producer.prototype.send = function(pushObject) {
    var diff, noChanges;
    pushObject.producer = this.name;
    pushObject.topic = "data";
    if (pushObject.reset) {
      this.cache = {};
    }
    pushObject = objectify(pushObject);
    diff = getChanges(this.cache, pushObject);
    noChanges = _.isEmpty(diff || !diff);
    this.debug("preparing data");
    if (noChanges) {
      this.debug("no changes");
    }
    if (diff) {
      diff.producer = this.name;
      diff.topic = "data";
    }
    if (!noChanges) {
      this.debug("sending data");
      pushSocket.send(JSON.stringify(diff));
    }
    if (!pushObject.reset) {
      return this.cache = _.merge(this.cache, pushObject);
    }
  };

  Producer.prototype.sendData = function(data, reset) {
    var pushObject;
    pushObject = {
      data: data,
      status: "running"
    };
    if (reset) {
      pushObject.reset = true;
    }
    return this.send(pushObject);
  };

  Producer.prototype.sendStatus = function(status) {
    var pushObject;
    pushObject = {
      status: status
    };
    return this.send(pushObject);
  };

  Producer.prototype.sendError = function(e) {
    var pushObject;
    pushObject = {
      error: e
    };
    return this.send(pushObject);
  };

  Producer.prototype.checkSubscriptionState = function() {
    var diffTime;
    if (!this.subscriptionTime) {
      return;
    }
    diffTime = new Date() - this.subscriptionTime;
    if (diffTime > this.stopIntervalTime) {
      this.debug("canceling subscription by calling 'stop'");
      this.stop();
      return this.subscriptionTime = false;
    }
  };

  Producer.prototype.subscribe = function() {
    this.subscriptionTime = new Date();
  };

  Producer.prototype.getStatus = function(callback) {
    if (callback) {
      if (this.cache) {
        this.debug(this.name + " sending from cache");
        callback(null, this.cache);
      }
      if (!this.cache) {
        return callback("no cache");
      }
    }
  };

  return Producer;

})(EventEmitter);

module.exports = Producer;
