// Generated by CoffeeScript 1.9.0
"use strict";
var Channels, EventEmitter, Producer, async, calculateRuntime, debug, emitter, exec, fs, getChannelType, helper, iconvlite, isWatching, ko, logger, moment, padTime, _,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

helper = require("omg-helperfunctions");

_ = require("lodash");

exec = require("child_process").exec;

iconvlite = require("iconv-lite");

fs = require("fs");

EventEmitter = require("events").EventEmitter;

emitter = new EventEmitter();

ko = require("knockout");

moment = require('moment');

async = require('async');

debug = require('debug')("omg-channels");

logger = require("omg-logger");

Producer = require("class_node_producer");

isWatching = false;

getChannelType = function(IlidType) {
  switch (IlidType) {
    case "S2M":
      return "PRI";
    case "FXS":
      return "Analog";
    case "S0":
      return "BRI";
    default:
      return "PCM";
  }
};

padTime = function(num) {
  num = "" + num;
  if (num.length === 1) {
    num = "0" + num;
  }
  return num;
};

calculateRuntime = function(date) {
  var diff, hours, minutes, now, seconds;
  debug(date);
  date = moment(date, "YYYY-MM-DD-hh:mm.ss").format();
  date = new Date(date);
  now = new Date();
  diff = now - date;
  diff = moment.duration(diff);
  hours = diff.get("hours");
  minutes = diff.get("minutes");
  seconds = diff.get("seconds");
  return (padTime(hours)) + ":" + (padTime(minutes)) + ":" + (padTime(seconds));
};

Channels = (function(_super) {
  __extends(Channels, _super);

  function Channels() {
    var addChangedFile, addOneBchannelState, allChannels, amountOfDifferentChannels, bchannels, changedFiles, checkInterval, dchannelsExtended, dchannelsFromGetChannels, dchannelsFromStatics, filesWithChangesQ, getActiveCalls, sendChanges, watchDir, watcher;
    Channels.__super__.constructor.call(this, "channels", 10000);
    watcher = false;
    watchDir = "/tmp/";
    bchannels = {};
    dchannelsFromStatics = ko.observable().extend({
      throttle: 100
    });
    dchannelsFromGetChannels = ko.observableArray().extend({
      throttle: 100
    });
    this.subscribeTo("statics", (function(_this) {
      return function(data) {
        var dchannels;
        dchannels = data && data.config && data.config.struct_Box && data.config.struct_Box.struct_DChannel;
        if (dchannels) {
          dchannelsFromStatics(dchannels);
          return _this.unsubscribeFrom("statics");
        }
      };
    })(this));
    this.requestData({
      producer: "statics",
      action: "getStatus"
    }, (function(_this) {
      return function(data) {
        var dchannels;
        dchannels = data && data.config && data.config.struct_Box && data.config.struct_Box.struct_DChannel;
        if (dchannels) {
          dchannelsFromStatics(dchannels);
          return _this.unsubscribeFrom("statics");
        }
      };
    })(this));
    dchannelsExtended = ko.computed((function(_this) {
      return function() {
        var dchannels;
        dchannels = [];
        _.each(dchannelsFromStatics(), function(dchannelOriginal, index) {
          var dchannelObject;
          dchannelObject = {
            name: dchannelOriginal.string_IlidSlot + "." + dchannelOriginal.string_IlidIndex,
            ilidType: dchannelOriginal.string_IlidType,
            ilidTypeUser: getChannelType(dchannelOriginal.string_IlidType)
          };
          return dchannels.push(dchannelObject);
        });
        return dchannels;
      };
    })(this));
    amountOfDifferentChannels = ko.computed(function() {
      var dchannels, dchannelsGrouped, supportedChannels;
      dchannels = dchannelsExtended();
      dchannelsGrouped = _.groupBy(dchannels, function(chan) {
        return chan.ilidType;
      });
      supportedChannels = {};
      _.each(dchannelsGrouped, function(chanObject, chanType) {
        return supportedChannels[chanType] = _.size(chanObject);
      });
      debug(supportedChannels);
      return supportedChannels;
    });
    allChannels = ko.computed(function() {
      return {
        bchannels: bchannels,
        dchannels: dchannelsExtended(),
        supportedChannels: amountOfDifferentChannels()
      };
    });
    changedFiles = [];
    checkInterval = false;
    exec("getchannels -m -b 2>&1 | grep -v 'B-Channels found'", (function(_this) {
      return function(error, stdout) {
        stdout = stdout.split("\n");
        stdout = _.filter(stdout, function(line) {
          return (line !== "") && (line.indexOf("B-Channels and") === -1);
        });
        _.each(stdout, function(bchannelName) {
          return bchannels[bchannelName] = {
            bchannel: bchannelName
          };
        });
        return _this.sendData(ko.toJS(allChannels));
      };
    })(this));
    exec("getchannels -d 2>&1 | grep -v 'D-Channels found'", (function(_this) {
      return function(error, stdout) {
        stdout = stdout.split("\n");
        stdout = _.filter(stdout, function(line) {
          return line !== "";
        });
        dchannelsFromGetChannels(stdout);
        return _this.sendData(ko.toJS(allChannels));
      };
    })(this));
    addOneBchannelState = function(filename, asyncCallback) {
      return fs.exists("" + watchDir + filename, function(exists) {
        if (!exists) {
          asyncCallback();
          return;
        }
        return fs.readFile("" + watchDir + filename, function(err, content) {
          var bchannelName, channelProperties, contentAsJson, decodedContent;
          decodedContent = iconvlite.decode(content, "utf-8");
          channelProperties = decodedContent.split("--");
          contentAsJson = {};
          _.each(channelProperties, function(keyValObject) {
            var newKey, newVal, tempArray;
            tempArray = keyValObject.split("=");
            newKey = tempArray[0];
            newVal = tempArray[1];
            try {
              newKey = JSON.parse(newKey);
            } catch (_error) {}
            try {
              newVal = JSON.parse(newVal);
            } catch (_error) {}
            return contentAsJson[newKey] = newVal;
          });
          bchannelName = contentAsJson.bchannel;
          if (bchannelName && bchannelName !== "undefined") {
            if (contentAsJson.error === "none" || contentAsJson.error === "active") {
              contentAsJson.active = "true";
            } else {
              contentAsJson.active = "false";
            }
            bchannels[bchannelName] = contentAsJson;
          }
          return asyncCallback();
        });
      });
    };
    getActiveCalls = function() {
      return exec("./activeCalls.lua", {
        cwd: __dirname + "/lua/"
      }, (function(_this) {
        return function(error, stdout, stderr) {
          var activeCalls, e;
          if (error) {
            logger.error(error);
          }
          if (stderr) {
            logger.warn(stderr);
          }
          activeCalls = [];
          if (stdout) {
            stdout = stdout.toString();
            try {
              activeCalls = JSON.parse(stdout);
            } catch (_error) {
              e = _error;
              logger.error(e.message);
            }
          }
          return _.each(activeCalls, function(call) {
            var channelToMergeWith;
            channelToMergeWith = _.findWhere(bchannels, {
              bchannel: call["interface"]
            });
            if (channelToMergeWith) {
              _.merge(channelToMergeWith, call);
              return debug("the channel is: " + channelToMergeWith);
            }
          });
        };
      })(this));
    };
    filesWithChangesQ = async.queue(addOneBchannelState, 1);
    filesWithChangesQ.drain = _.throttle(getActiveCalls, 2000);
    addChangedFile = function(event, filename) {
      if ((filename.lastIndexOf("BChannelState", 0) === 0) && (changedFiles.indexOf(filename) === -1)) {
        debug("A file in /tmp changed " + filename);
        return filesWithChangesQ.push(filename);
      }
    };
    sendChanges = (function(_this) {
      return function() {
        var activeChannels;
        activeChannels = _.filter(bchannels, {
          active: "true"
        });
        _.each(activeChannels, function(chan) {
          return chan.runTime = calculateRuntime(chan.date);
        });
        return _this.sendData(ko.toJS(allChannels()));
      };
    })(this);
    allChannels.subscribe(function() {
      return sendChanges();
    }, true);
    this.start = (function(_this) {
      return function() {
        var checkInitialBchannels;
        if (checkInterval) {
          clearInterval(checkInterval);
        }
        checkInterval = setInterval(sendChanges, 2000);
        if (!watcher) {
          watcher = fs.watch(watchDir, addChangedFile);
        }
        checkInitialBchannels = function(err, files) {
          return _.each(files, function(file) {
            return addChangedFile(null, file);
          });
        };
        fs.readdir(watchDir, checkInitialBchannels);
        return debug("started");
      };
    })(this);
    this.stop = (function(_this) {
      return function() {
        if (watcher) {
          watcher.close();
        }
        watcher = false;
        clearInterval(checkInterval);
        isWatching = false;
        return debug("stopped, isWatching is " + isWatching);
      };
    })(this);
  }

  Channels.prototype.subscribe = function() {
    if (!isWatching) {
      debug("Not watching, subscription possible");
      isWatching = true;
      this.start();
    }
    return Channels.__super__.subscribe.apply(this, arguments);
  };

  return Channels;

})(Producer);

module.exports = new Channels();
