// Generated by CoffeeScript 1.9.0
var Coredumpcheck, Producer, exec, fs, isWatching, logger, watchDir, _,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

_ = require("lodash");

fs = require('fs');

exec = require("child_process").exec;

logger = require("omg-logger");

Producer = require("class_node_producer");

isWatching = false;

watchDir = "/usr/fb/bin/sipisdn/";

Coredumpcheck = (function(_super) {
  __extends(Coredumpcheck, _super);

  function Coredumpcheck() {
    var allDumpFiles, dumpFiles, getDumpFiles, send, throttledGetAndSend;
    Coredumpcheck.__super__.constructor.call(this, "coredumpcheck", 10 * 1000);
    dumpFiles = [];
    allDumpFiles = [];
    getDumpFiles = (function(_this) {
      return function(callback) {
        return fs.readdir(watchDir, function(error, files) {
          var fileName;
          if (error) {
            logger.error(error);
          }
          allDumpFiles = (function() {
            var _i, _len, _results;
            _results = [];
            for (_i = 0, _len = files.length; _i < _len; _i++) {
              fileName = files[_i];
              if (fileName.lastIndexOf("core", 0) === 0) {
                _results.push({
                  name: fileName,
                  time: (new Date()).toString()
                });
              }
            }
            return _results;
          })();
          if (callback) {
            return callback();
          }
        });
      };
    })(this);
    send = (function(_this) {
      return function() {
        return _this.sendData(allDumpFiles, true);
      };
    })(this);
    throttledGetAndSend = _.throttle(function() {
      return getDumpFiles(send);
    }, 1000);
    this.start = (function(_this) {
      return function() {
        var watcher;
        getDumpFiles(send);
        if (watcher) {
          watcher.close();
        }
        watcher = false;
        return watcher = fs.watch(watchDir, function(event, filename) {
          logger.silly(filename + " changed: " + event);
          if (filename.lastIndexOf("core", 0) === 0) {
            return throttledGetAndSend();
          }
        });
      };
    })(this);
    this.stop = (function(_this) {
      return function() {
        var watcher;
        isWatching = false;
        if (watcher) {
          watcher.close();
        }
        return watcher = false;
      };
    })(this);
    this["delete"] = (function(_this) {
      return function(file) {
        if (file === "all") {
          logger.silly("deleting all core dumps");
          return fs.readdir(watchDir, function(error, files) {
            var fileName;
            if (error) {
              logger.error(error);
            }
            allDumpFiles = (function() {
              var _i, _len, _results;
              _results = [];
              for (_i = 0, _len = files.length; _i < _len; _i++) {
                fileName = files[_i];
                if (fileName.lastIndexOf("core", 0) === 0) {
                  _results.push(fileName);
                }
              }
              return _results;
            })();
            return _.each(allDumpFiles, function(fileName) {
              fs.unlink("" + watchDir + fileName);
              return _this.start();
            });
          });
        } else {
          return fs.readdir(watchDir, function(error, files) {
            if (files.indexOf(file !== -1)) {
              logger.debug("deleting " + file);
              fs.unlink("" + watchDir + file);
              return _this.start();
            }
          });
        }
      };
    })(this);
    this.getStatus = (function(_this) {
      return function(callback) {
        return _this.replyData(allDumpFiles, callback);
      };
    })(this);
  }

  Coredumpcheck.prototype.subscribe = function() {
    if (!isWatching) {
      isWatching = true;
      this.start();
    }
    return Coredumpcheck.__super__.subscribe.apply(this, arguments);
  };

  return Coredumpcheck;

})(Producer);

module.exports = new Coredumpcheck();
