// Generated by CoffeeScript 1.9.0

/*
* omg-diskspace
*
* Copyright (c) 2014 Johannes Noe
* Licensed under the MIT license.
 */
"use strict";
var Diskspace, Producer, df,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

df = require("nodejs-disks");

Producer = require("class_node_producer");

Diskspace = (function(_super) {
  var isRunning;

  __extends(Diskspace, _super);

  isRunning = false;

  function Diskspace() {
    this.subscribe = __bind(this.subscribe, this);
    var getDiskSpace, run;
    Diskspace.__super__.constructor.call(this, "diskspace", 10 * 1000);
    getDiskSpace = false;
    run = (function(_this) {
      return function() {
        _this.debug("running");
        return df.drives(function(err, drives) {
          return df.drivesDetail(drives, function(err, data) {
            var oneDrive, volumes, _i, _len;
            volumes = {};
            for (_i = 0, _len = data.length; _i < _len; _i++) {
              oneDrive = data[_i];
              if (oneDrive.mountpoint !== "") {
                volumes[oneDrive.mountpoint] = oneDrive;
              }
            }
            return _this.sendData(volumes);
          });
        });
      };
    })(this);
    run();
    this.start = (function(_this) {
      return function() {
        _this.debug("starting");
        run();
        if (getDiskSpace) {
          clearInterval(getDiskSpace);
        }
        return getDiskSpace = setInterval(run, 20 * 1000);
      };
    })(this);
    this.stop = (function(_this) {
      return function() {
        if (getDiskSpace) {
          clearInterval(getDiskSpace);
        }
        return isRunning = false;
      };
    })(this);
  }

  Diskspace.prototype.subscribe = function() {
    if (!isRunning) {
      isRunning = true;
      this.start();
    }
    return Diskspace.__super__.subscribe.apply(this, arguments);
  };

  return Diskspace;

})(Producer);

module.exports = new Diskspace();
