// Generated by CoffeeScript 1.9.0

/*
 * omg-isdnconnectionsstate
 *
 * Copyright (c) 2014 Johannes Noe
 * Licensed under the MIT license.
 */
'use strict';
var IsdnConnectionState, Producer, debug, exec, fs, _,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

exec = require("child_process").exec;

_ = require("lodash");

fs = require('fs');

debug = require("debug")("omg-isdnconnectionsstate");

Producer = require("class_node_producer");

IsdnConnectionState = (function(_super) {
  var isRunning;

  __extends(IsdnConnectionState, _super);

  isRunning = false;

  function IsdnConnectionState() {
    this.subscribe = __bind(this.subscribe, this);
    var getNewData, run;
    IsdnConnectionState.__super__.constructor.call(this, "isdnconnectionsstate", 15 * 1000);
    getNewData = false;
    run = (function(_this) {
      return function() {
        return exec("LC_ALL=C getstates", function(error, stdout) {
          var col, cols, item, key, line, lines, sep, splitStdout, states, val, _i, _len;
          states = {};
          splitStdout = stdout.split("\n");
          lines = _.without(splitStdout, "");
          for (key in lines) {
            line = lines[key];
            item = {};
            cols = line.split(", ");
            for (_i = 0, _len = cols.length; _i < _len; _i++) {
              col = cols[_i];
              sep = col.split(":");
              key = sep[0];
              val = sep[1];
              item[key] = val;
            }
            states[item.ILID] = item;
          }
          debug("sending states");
          return _this.sendData(states);
        });
      };
    })(this);
    run();
    this.start = (function(_this) {
      return function() {
        _this.debug("starting");
        run();
        if (getNewData) {
          clearInterval(getNewData);
        }
        return getNewData = setInterval(run, 5 * 1000);
      };
    })(this);
    this.stop = (function(_this) {
      return function() {
        if (getNewData) {
          clearInterval(getNewData);
        }
        return isRunning = false;
      };
    })(this);
  }

  IsdnConnectionState.prototype.subscribe = function() {
    if (!isRunning) {
      isRunning = true;
      this.start();
    }
    return IsdnConnectionState.__super__.subscribe.apply(this, arguments);
  };

  return IsdnConnectionState;

})(Producer);

module.exports = new IsdnConnectionState();
