// Generated by CoffeeScript 1.9.0
'use strict';
var Licenses, Producer, async, debug, exec, fs, logger, _,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

exec = require("child_process").exec;

fs = require('fs');

_ = require("lodash");

async = require('async');

debug = require("debug")("omg-licenses");

logger = require("omg-logger");

Producer = require("class_node_producer");

Licenses = (function(_super) {
  var isRunning;

  __extends(Licenses, _super);

  isRunning = false;

  function Licenses() {
    this.subscribe = __bind(this.subscribe, this);
    var checkEachLicense, dchannels, formattedTodayString, getAllLicenses, getsupportedChannels, outOfDateLics, run, watchDir, watcher;
    Licenses.__super__.constructor.call(this, "licenses", 15 * 1000);
    dchannels = {};
    formattedTodayString = function() {
      var currentDate, day, month, year;
      currentDate = new Date();
      year = currentDate.getFullYear();
      month = currentDate.getMonth() + 1;
      month = ("0" + month).slice(-2);
      day = currentDate.getDate();
      day = ("0" + day).slice(-2);
      return "" + year + month + day;
    };
    outOfDateLics = [];
    getAllLicenses = (function(_this) {
      return function(noDiff) {
        debug("getting licinfo");
        return exec("licinfo -d 2>&1", function(error, stdout, stderr) {
          var analog, directoryService, entryControl, line, newstdout, pcm, pcmLicensed, s0, s2m, sip2lync, splitLine, umLines, _i, _len;
          newstdout = {};
          if (stdout) {
            stdout = stdout.split("\n");
            for (_i = 0, _len = stdout.length; _i < _len; _i++) {
              line = stdout[_i];
              splitLine = line.split(":");
              if (splitLine[0]) {
                newstdout[splitLine[0]] = splitLine[3];
              }
            }
            if (newstdout["43MaxLines"]) {
              s2m = newstdout["43MaxLines"];
            }
            if (!dchannels.S2M || s2m === -1 || s2m > dchannels.S2M) {
              s2m = dchannels.S2M;
            }
            if (s2m) {
              newstdout.S2M = s2m;
            }
            delete newstdout["43MaxLines"];
            if (newstdout["44MaxLines"]) {
              s0 = newstdout["44MaxLines"];
            }
            if (!dchannels.S0 || s0 === -1 || s0 > dchannels.S0) {
              s0 = dchannels.S0;
            }
            if (s0) {
              newstdout.S0 = s0;
            }
            delete newstdout["44MaxLines"];
            if (newstdout["47MaxLines"]) {
              analog = newstdout["47MaxLines"];
            }
            if (!dchannels.FXS || analog === -1 || analog > dchannels.FXS) {
              analog = dchannels.FXS;
            }
            if (analog) {
              newstdout.FXS = analog;
            }
            delete newstdout["47MaxLines"];
            if (newstdout["54MaxLines"] && newstdout["54MaxLines"] !== ("0" || "")) {
              pcmLicensed = true;
            }
            delete newstdout["54MaxLines"];
            if (newstdout["55MaxLines"] && pcmLicensed) {
              pcm = newstdout["55MaxLines"];
            }
            if (!dchannels.PCM || pcm === -1 || pcm > dchannels.PCM) {
              pcm = dchannels.PCM;
            }
            if (pcm) {
              newstdout.PCM = pcm;
            }
            if (newstdout["55MaxLines"] && pcmLicensed) {
              newstdout.sip2sip = newstdout["55MaxLines"];
            }
            delete newstdout["55MaxLines"];
            if (newstdout["45MaxLines"]) {
              umLines = newstdout["45MaxLines"];
            }
            newstdout.umLines = umLines;
            delete newstdout["45MaxLines"];
            delete newstdout["48MaxLines"];
            if (newstdout["56Enable"]) {
              directoryService = newstdout["56Enable"];
            }
            if (directoryService === "1") {
              newstdout.directoryService = "∞";
            }
            delete newstdout["56Enable"];
            if (newstdout["57MaxUsers"]) {
              sip2lync = newstdout["57MaxUsers"];
            }
            if (sip2lync === "-1") {
              sip2lync = "∞";
            }
            newstdout.sip2lync = sip2lync;
            delete newstdout["57MaxUsers"];
            if (newstdout["58MaxLines"]) {
              entryControl = newstdout["58MaxLines"];
            }
            newstdout.entryControl = entryControl;
            delete newstdout["58MaxLines"];
            newstdout.outOfDate = outOfDateLics;
            if (noDiff) {
              _this.sendData(newstdout, true);
            }
            return _this.sendData(newstdout);
          } else if (error) {
            if (error) {
              logger.error(error);
            }
            return _this.sendError(error);
          } else if (stderr) {
            return _this.sendError(stderr);
          }
        });
      };
    })(this);
    checkEachLicense = (function(_this) {
      return function(licenseFiles) {
        var allChecked, checkOneLicFile;
        outOfDateLics = [];
        allChecked = function(err) {
          debug("all licenses checked. Out of date: " + outOfDateLics.length);
          return getAllLicenses("noDiff");
        };
        checkOneLicFile = function(licfile, asyncCallback) {
          debug("checking " + licfile);
          return exec("licinfo -d -l " + licfile + " 2>&1", {
            cwd: "/data/"
          }, function(error, stdout) {
            var isExpired, licExpirationDate, licObject, licenseDetails, line, splitLine, today, _i, _len;
            licObject = {};
            if (stdout) {
              stdout = stdout.split("\n");
              for (_i = 0, _len = stdout.length; _i < _len; _i++) {
                line = stdout[_i];
                splitLine = line.split(":");
                if (splitLine[0]) {
                  licObject[splitLine[0]] = splitLine[3];
                }
              }
            }
            licExpirationDate = licObject["0DateLimit"];
            today = formattedTodayString();
            isExpired = false;
            if (licExpirationDate && licExpirationDate < today) {
              isExpired = true;
            }
            licenseDetails = {
              serial: licObject["0SerialCode"],
              expirationDate: licExpirationDate
            };
            if (isExpired) {
              outOfDateLics.push(licenseDetails);
            }
            return asyncCallback(null);
          });
        };
        return async.mapSeries(licenseFiles, checkOneLicFile.bind(checkOneLicFile), allChecked);
      };
    })(this);
    getsupportedChannels = (function(_this) {
      return function() {
        return _this.requestData({
          producer: "channels",
          action: "getStatus"
        }, function(message) {
          if (message && message.outputMessage && message.outputMessage.supportedChannels) {
            return _.merge(dchannels, message.outputMessage.supportedChannels);
          }
        });
      };
    })(this);
    run = (function(_this) {
      return function() {
        var tryAgain;
        if (!(dchannels && !_.isEmpty(dchannels))) {
          getsupportedChannels();
          debug("Supported channels not set, yet.");
          tryAgain = function() {
            return run();
          };
          setTimeout(tryAgain, 500);
          return;
        }
        return fs.readdir("/data/", function(err, filesInData) {
          var file, licenseFiles;
          licenseFiles = (function() {
            var _i, _len, _results;
            _results = [];
            for (_i = 0, _len = filesInData.length; _i < _len; _i++) {
              file = filesInData[_i];
              if (file.match(/\.fle/)) {
                _results.push(file);
              }
            }
            return _results;
          })();
          return checkEachLicense(licenseFiles);
        });
      };
    })(this);
    getAllLicenses();
    watcher = false;
    watchDir = "/data/";
    this.start = (function(_this) {
      return function() {
        var throttledRunAfterFileChange;
        _this.debug("starting");
        getAllLicenses();
        run();
        if (watcher) {
          watcher.close();
        }
        watcher = false;
        _this.sendStatus("running");
        throttledRunAfterFileChange = _.throttle(run, 100, {
          trailing: false
        });
        return watcher = fs.watch(watchDir, function(event, filename) {
          if (filename.match(/\.fle|\.flf/)) {
            return throttledRunAfterFileChange();
          }
        });
      };
    })(this);
    this.stop = (function(_this) {
      return function() {
        isRunning = false;
        watcher.close();
        watcher = false;
        return _this.sendStatus("stopped");
      };
    })(this);
  }

  Licenses.prototype.subscribe = function() {
    if (!isRunning) {
      isRunning = true;
      this.start();
    }
    return Licenses.__super__.subscribe.apply(this, arguments);
  };

  return Licenses;

})(Producer);

module.exports = new Licenses();
