// Generated by CoffeeScript 1.9.0
var AggConnection, logger,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

logger = require("omg-logger");

AggConnection = (function() {
  function AggConnection(_at_producer) {
    var aggConfig, config, host, sendSubscription, zmq;
    this.producer = _at_producer;
    this.stop = __bind(this.stop, this);
    this.start = __bind(this.start, this);
    this.getStatus = __bind(this.getStatus, this);
    this.onSub = __bind(this.onSub, this);
    zmq = require('zmq');
    config = require("/data/config.json");
    aggConfig = config.agg;
    host = aggConfig.protocol + ("://" + aggConfig.address + ":");
    this.pushSocket = zmq.socket('push');
    this.pushSocket.connect(host + aggConfig.subscriberPoolPort);
    this.subSocket = zmq.socket('sub');
    this.subSocket.connect(host + aggConfig.pubSub);
    this.requestSocket = zmq.socket('req');
    this.requestSocket.connect(host + aggConfig.reqRep);
    this.subSocket.subscribe(this.producer);
    sendSubscription = (function(_this) {
      return function() {
        var requestObject;
        requestObject = {
          topic: "subscription",
          action: "subscribe",
          producer: _this.producer
        };
        return _this.pushSocket.send(JSON.stringify(requestObject));
      };
    })(this);
    sendSubscription();
  }

  AggConnection.prototype.onSub = function(callback) {
    return this.subSocket.on("message", function(message) {
      var e, msg;
      msg = [];
      Array.prototype.slice.call(arguments).forEach(function(arg) {
        return msg.push(arg.toString());
      });
      msg.shift();
      message = msg.join(" ");
      try {
        message = JSON.parse(message);
      } catch (_error) {
        e = _error;
        logger.error(e);
      }
      return callback(message);
    });
  };

  AggConnection.prototype.getStatus = function(callback) {
    var reqRepRequestObject;
    reqRepRequestObject = {
      topic: "request",
      action: "getStatus",
      producer: this.producer
    };
    this.requestSocket.once("message", function(message) {
      var e;
      message = message.toString();
      message = message.split(" ");
      message = message.pop();
      try {
        message = JSON.parse(message);
      } catch (_error) {
        e = _error;
        logger.error(e);
      }
      return callback(message.status);
    });
    return this.requestSocket.send(JSON.stringify(reqRepRequestObject));
  };

  AggConnection.prototype.start = function(args) {
    var requestObject;
    requestObject = {
      topic: "subscription",
      action: "subscribe",
      producer: this.producer
    };
    this.pushSocket.send(JSON.stringify(requestObject));
    requestObject = {
      topic: "command",
      action: "start",
      producer: this.producer,
      args: args ? args : void 0
    };
    return this.pushSocket.send(JSON.stringify(requestObject));
  };

  AggConnection.prototype.stop = function() {
    var requestObject;
    requestObject = {
      topic: "command",
      action: "stop",
      producer: this.producer
    };
    return this.pushSocket.send(JSON.stringify(requestObject));
  };

  return AggConnection;

})();

module.exports = AggConnection;
