// Generated by CoffeeScript 1.9.0
var Call, EventEmitter, appConfig, child_process, debug, events, ko, runAsRoot, testcallFolder,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

child_process = require('child_process');

debug = require("debug")("omg-testcall.js:Call");

ko = require('knockout');

events = require('events');

EventEmitter = events.EventEmitter;

testcallFolder = "/tmp/testcall";

appConfig = global.appConfig;

if (appConfig) {
  runAsRoot = appConfig.sudo || false;
}

Call = (function(_super) {
  __extends(Call, _super);

  function Call() {
    this.running = ko.observable(false);
  }

  Call.prototype.start = function(callObject) {
    var callingPartyName, optionsPath, redirectedNumber, sippOptions;
    if (this.running()) {
      debug("Call still running, wait!");
      return;
    }
    debug("Starting call");
    this.running(true);
    redirectedNumber = callObject.redirectedNumber;
    callingPartyName = callObject.callerName;
    optionsPath = testcallFolder + "/options.xml";
    if (redirectedNumber && !callingPartyName) {
      optionsPath = testcallFolder + "/options_redirected.xml";
    }
    if (!redirectedNumber && callingPartyName) {
      optionsPath = testcallFolder + "/options_callername.xml";
    }
    if (redirectedNumber && callingPartyName) {
      optionsPath = testcallFolder + "/options_callername_redirected.xml";
    }
    sippOptions = ["-skip_rlimit -silent -max_socket 50000 -sf " + optionsPath + " -mp 6000 -trace_msg -trace_shortmsg -trace_logs -trace_err -m 1 -users 1 -pause_msg_ign"];
    return child_process.exec(__dirname + "/bash/primaryAddress.sh", (function(_this) {
      return function(error, stdout) {
        var argCmd, args, callProcess, command, localAddress, msg;
        if (error) {
          msg = "Could not dertermine localAddress! (" + __dirname + "/bash/primaryAddress.sh failed!)";
          _this.emit("error", error);
          debug("error getting primaryAddress: " + error);
          return;
        }
        localAddress = stdout.replace(/\n/g, "");
        if (runAsRoot) {
          command = "sudo";
          args = ["sipp"];
        } else {
          command = "sipp";
          args = [];
        }
        args.push(callObject.host + ":" + callObject.port);
        switch (callObject.proto.toUpperCase()) {
          case "TCP":
            args.push("-t t1");
            break;
          case "TLS":
            args.push("-t l1");
            break;
          case "UDP":
            args.push("-t u1");
        }
        args.push("-i " + localAddress);
        args.push("-mi " + localAddress);
        args.push("-s " + callObject.calledPartyNumber);
        args.push("-set callingPartyNumber " + callObject.callingPartyNumber);
        if (redirectedNumber) {
          args.push("-set redirectedNumber " + redirectedNumber);
        }
        if (callingPartyName) {
          args.push("-set callingPartyName " + callingPartyName);
        }
        argCmd = args.concat(sippOptions);
        argCmd = argCmd.join(" ").split(new RegExp(" "));
        callProcess = child_process.spawn(command, argCmd, {
          cwd: "/tmp/"
        });
        _this.emit("status", "started");
        _this.emit("status", "running");
        callProcess.on("error", function(err) {
          _this.emit("status", "stopped");
          _this.emit("error", err);
        });
        callProcess.stderr.on("data", function(data) {
          var match, normalStdErr;
          data = data.toString("utf-8");
          match = data.match("Address already in use");
          debug("callProcess error: " + data);
          normalStdErr = data.match("Generated SSRC");
          if (!normalStdErr) {
            return _this.emit("data", [data]);
          }
        });
        return callProcess.on("close", function(code) {
          _this.emit("finished");
          return _this.running(false);
        });
      };
    })(this));
  };

  return Call;

})(EventEmitter);

module.exports = new Call();
